package test;

public class RecursiveTest {
	public static final int N = 1000;
	private static Job job;
	interface Job {
		void perform();
	}
	private static class Pi implements Job{		
		@Override
		public void perform() {
			double x = Math.PI*2.0;
		}
	}
	private static class Sqrt implements Job{		
		@Override
		public void perform() {
			double x = Math.sqrt(2.0);
		}
	}
	private static class Sin implements Job{		
		@Override
		public void perform() {
			double x = Math.sin(2.0);
		}
	}
	private static class Log implements Job{		
		@Override
		public void perform() {
			double x = Math.log(2.0);
		}
	}
	private static class Rand implements Job {
		@Override
		public void perform() {
			double x = Math.random();
		}
	}
	public static void main(String[] args) throws InterruptedException {
		StopWatch sw = new StopWatch();
		Job[] jobs = {new Pi(), new Rand(), new Sqrt(), new Sin(), new Log()};
		int r = (int)(Math.random()*2);
		job = jobs[(int)(Math.random()*jobs.length)];
		switch(r){
		case 0: 
			loop1(0);
			break;
		case 1:
			rec1(0);
			break;
		}
		System.out.println(r+","+job.getClass().getSimpleName()+":"+sw);
	}
	private static void loop1(int n) {
		for(int i=n; i<N; i++)
			loop2(0);
	}
	private static void loop2(int i) {
		for(int j=i; j<N; j++)
			loop3(0);
	}
	private static void loop3(int i) {
		for(int k=i; k<N; k++){
			job.perform();
		}
	}
	private static void rec1(int n) throws InterruptedException{
		if(n<N){
			rec2(0);
			rec1(n+1);
		}
	}
	private static void rec2(int n) {
		if(n<N){
			rec3(0);
			rec2(n+1);
		}
	}
	private static void rec3(int n) {
		if(n<N){
			job.perform();
			rec3(n+1);
		}
	}
}
